"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
var core_1 = require("@babel/core");
var buildEnumWrapper = core_1.template("\nconst ID = (function () {\n  ENUM;\n  return ID\n})()\n");
var IIFE_ENUM = '__ENUM_IIFE__';
var plugin = function () {
    return {
        name: 'ts-enum-iife',
        inherits: require('@babel/plugin-syntax-typescript')["default"],
        visitor: {
            TSEnumDeclaration: function (path) {
                var _a;
                if (path.node.leadingComments &&
                    path.node.leadingComments.toString().indexOf(IIFE_ENUM) >= -1) {
                    return;
                }
                var nextNode = buildEnumWrapper({
                    ID: core_1.types.clone(path.node.id),
                    ENUM: __assign(__assign({}, path.node), { leadingComments: __spreadArrays((((_a = path.node) === null || _a === void 0 ? void 0 : _a.leadingComments) || []), [
                            {
                                type: 'LineComponent',
                                value: IIFE_ENUM
                            },
                        ]) })
                });
                path.replaceWith(nextNode);
            }
        }
    };
};
exports["default"] = plugin;
